#include <stdio.h>
#include <libv.h>

typedef enum
{
	reg_type_unknown,
	reg_type_dword,
	reg_type_string,
	reg_type_binary,
}	reg_type_t;

typedef struct	reg_value_s
{
	char		*key;
	reg_type_t	type;
	u32_t		len;
	void		*value;
}	reg_value_t, *reg_value_p;

V_LOCAL	reg_value_p
alloc_reg_value(char *key,u32_t type_size)
{
	reg_value_t *res;
	u32_t size, key_len;
	key_len=strlen(key)+1;
	size=sizeof(reg_value_t)+key_len+type_size+8;
	res=(reg_value_t*)malloc(size);
	res->key=(char*)(res+1);
	while(res->key & 3)
		res->key++;
	res->value=res->key+key_len;
	while(res->value & 3)
		res->value++;
	strcpy(res->key,key);
	res->len=type_size;
}

V_LOCAL	reg_value_p
alloc_dword_value(char *key,u32_t value)
{
	reg_value_t *res;
	res=alloc_reg_value(key,sizeof(u32_t));
	reg->type=reg_type_dword;
	*((u32_t*)reg->value)=value;
}

V_LOCAL	reg_value_p
alloc_binary_value(char *key,void *source,u32_t len)
{
	reg_value_t *res;
	res=alloc_reg_value(key,len);
	reg->type=reg_type_binary;
	v_copy(reg->value,source,len);
}

V_LOCAL	reg_value_p
alloc_string_value(char *key,char *value)
{
	reg_value_t *res;
	u32_t len;
	len=strlen(value)+1;
	res=alloc_reg_value(key,len);
	reg->type=reg_type_string;
	v_copy(reg->value,value,len);
}


typedef	vp_stack_t	registry;

regSet

/*
typedef struct reg_node_s
{
	char	*name;
	struct	reg_node_s *prev, *next;

vboolean	regGetValue(char *key,char *value);
vboolean	regSetValue(char *key,char *value);

vboolean	i4_get_registry(i4_registry_type type, 
                        char *path, 
                        char *key_name,
                        char *buffer, int buf_length)
{
  HKEY key;

  if (RegOpenKeyEx(type==I4_REGISTRY_MACHINE ? HKEY_LOCAL_MACHINE : HKEY_CURRENT_USER,
                   path,
                   0,
                   KEY_READ,
                   &key)==ERROR_SUCCESS)
  {
    for (int i=0; 1; i++)
    {
      char name[256];
      DWORD name_size=256, type;
      DWORD data_size=buf_length;
     


      if (RegEnumValue(key, i, name, &name_size, 0, 
                     &type, 
                     (LPBYTE)buffer, 
                     &data_size)==ERROR_SUCCESS)
      {
        if (strcmp(name, key_name)==0)
        {
          RegCloseKey(key);
          return i4_T;
        }
      }
      else
      {
        RegCloseKey(key);
        return i4_F;
      }
    }
  }
  return i4_F;
}


i4_bool i4_set_registry(i4_registry_type type, 
                        char *path, 
                        char *key_name,
                        char *buffer)
{
  HKEY key;

  if (RegCreateKey(type==I4_REGISTRY_MACHINE ? HKEY_LOCAL_MACHINE : HKEY_CURRENT_USER,
                 path,
                 &key)==ERROR_SUCCESS)
  {
    RegSetValueEx(key, key_name, 0, REG_SZ, (w8 *)buffer, strlen(buffer)+1);
    RegCloseKey(key);
    return i4_T;
  }
  
  return i4_F;
}

*/