#include <user\mmplus.h>
#include <dsound.h>
#pragma hdrstop
#include <stdio.h>
#include <conio.h>

//   -       
typedef enum
{
  soSelf, soExternal
} TSoundOwner;

#error 14    ,   

//    API IDirectSound
class CSoundEngine : public CErrorReport, public MemOverride
{
private:
  static char           *szSelf;
protected:
  IDirectSound          *lpDS;
  DWORD                 dwMaxDsBuffers;
  //  :
  IDirectSoundBuffer    **alpDSB;
  //    :
  CWave                 **aAttachedSounds;
  //   :
  TSoundOwner           *aOwners;
  //  ,    
  HWND                  hAppWnd;
  HRESULT               LastErrorCode;
  void                  ReleaseAll();
  void                  ResetAll();
  void                  RecreateAll(HWND hWnd,DWORD dwMaxDsBuffers);
public:
                        CSoundEngine(HWND hWnd,DWORD dwMaxDsBuffers);
  virtual               ~CSoundEngine();
  BOOL                  LastError() {return LastErrorCode!=DS_OK;}
  int                   CreateBuffer(char *lpszId);
  int                   CreateBuffer(CWave *lpWave);
  void                  ReleaseBuffer(int iBuffer);
  void                  PlayBuffer(int iBuffer);
  void                  SetVolume(int iBuffer, long lVol);
  void                  SetPan(int iBuffer, long lPan);
  void                  SetFrequency(int iBuffer, long lFreq);
};

void CSoundEngine::ResetAll()
{
  lpDS=NULL;
  alpDSB=NULL;
  aAttachedSounds=NULL;
  aOwners=NULL;
  dwMaxDsBuffers=0;
  LastErrorCode=DSERR_GENERIC;
}

void CSoundEngine::ReleaseAll()
{
  int i;
  if((alpDSB==NULL)||(aAttachedSounds==NULL)||(aOwners==NULL))
  {
    if(alpDSB) 
    {
      free(alpDSB);
      alpDSB=NULL;
    }
    if(aAttachedSounds) 
    {
      free(aAttachedSounds);
      aAttachedSounds=NULL;
    }
    if(aOwners) 
    {
      free(aOwners);
      aOwners=NULL;
    }
    if(lpDS) 
    {
      lpDS->Release();
      lpDS=NULL;
    }
    return;
  }
  for(i=0;i<dwMaxDsBuffers;i++)
  {
    if(alpDSB[i]) alpDSB[i]->Release();
    if(aAttachedSounds[i]) 
      if(aOwners[i]==soSelf) 
        delete aAttachedSounds[i];
  }
  if(lpDS) lpDS->Release();
  lpDS=NULL;
  free(alpDSB);
  alpDSB=NULL;
  free(aAttachedSounds);
  aAttachedSounds=NULL;
  free(aOwners);
  aOwners=NULL;
}

void CSoundEngine::RecreateAll(HWND hWnd,DWORD dwMaxDsBuffers)
{
  ReleaseAll();
  ResetAll();
  if(hWnd==NULL)
  {
    Report("CSoundEngine->RecreateAll:   ");
    return;
  }
  if((dwMaxDsBuffers==0)||(dwMaxDsBuffers>1024))
  {
    Report("   'CSoundEngine'\n"
      "  1  1024  .");
    return;
  }
  this->dwMaxDsBuffers=dwMaxDsBuffers;
  if(dwMaxDsBuffers==0) return;
  alpDSB=(IDirectSoundBuffer**)
    malloc(dwMaxDsBuffers*sizeof(IDirectSoundBuffer*));
  aAttachedSounds=(CWave**)malloc(dwMaxDsBuffers*sizeof(CWave*));
  aOwners=(TSoundOwner*)malloc(dwMaxDsBuffers*sizeof(TSoundOwner));
  if((alpDSB==NULL)||(aAttachedSounds==NULL)||(aOwners)) return;
  memset(alpDSB,0,dwMaxDsBuffers*sizeof(IDirectSoundBuffer*));
  memset(aAttachedSounds,0,dwMaxDsBuffers*sizeof(CWave*));
  memset(aOwners,0,dwMaxDsBuffers*sizeof(TSoundOwner));
  hAppWnd=hWnd;
  LastErrorCode=DirectSoundCreate(NULL,&lpDS,NULL);
  if(LastErrorCode!=DS_OK)
  {
    lpDS=NULL;
    return;
  }
  LastErrorCode=lpDS->SetCooperativeLevel(hAppWnd,DSSCL_NORMAL);
}

CSoundEngine::CSoundEngine(HWND hWnd,DWORD dwMaxDsBuffers)
{
  szSelf="CSoundEngine";
  ResetAll();
  RecreateAll(hWnd,dwMaxDsBuffers);
}

CSoundEngine::~CSoundEngine()
{
  ReleaseAll();
}

int CSoundEngine::CreateBuffer(char *lpszId)
{
  int i;
  int iBuffer=-1;
  CWave *lpW;
  void *lpDest, *lpDest2;
  IDirectSoundBuffer *lpDSB;
  DWORD dwBytes, dwBytes2;
  LastErrorCode=DSERR_GENERIC;
  if((alpDSB==NULL)||(aAttachedSounds==NULL)) 
  {
    Report("%s->CreateBuffer:  \n"
      "   ",szSelf);
    return -1;
  }
  //        
  for(i=0;i<dwMaxDsBuffers;i++)
  {
    if(alpDSB[i]==NULL)
    {
      iBuffer=i;
      break;
    }
  }
  if(iBuffer==-1)
  {
    Report("%s->CreateBuffer:  \n"
      "     ",szSelf);
    return -1;
  }
  //  
  lpW = new CWave;
  lpW->LoadHeader(lpszId);
  if(lpW->LastError())
  {
    delete lpW;
    //   ,     - 
    if(HIWORD(lpszId))
      Report("%s->CreateBuffer:  \n"
        "  '%s'",szSelf,lpszId);
    else
      Report("%s->CreateBuffer:  \n"
        "    '%8X'",szSelf,lpszId);
    return -1;
  }
  DSBUFFERDESC bd;
  memset(&bd,0,sizeof(DSBUFFERDESC));
  bd.dwSize=sizeof(DSBUFFERDESC);
  bd.dwFlags=DSBCAPS_CTRLFREQUENCY|DSBCAPS_CTRLPAN|DSBCAPS_CTRLVOLUME;
  bd.dwBufferBytes=lpW->GetWaveSize();
  bd.lpwfxFormat=lpW->GetWaveFormatEx();
  LastErrorCode=lpDS->CreateSoundBuffer(&bd,&lpDSB,NULL);
  if(LastErrorCode!=DS_OK)
  {
    //        , 
    //   ,  :
    bd.dwFlags=DSBCAPS_CTRLVOLUME;
    LastErrorCode=lpDS->CreateSoundBuffer(&bd,&lpDSB,NULL);
    if(LastErrorCode!=DS_OK)
    {
      Report("%s->CreateBuffer:\n"
        "  IDirectSound->CreateSoundBuffer",szSelf);
      delete lpW;
      return -1;
    }
  }
  //       
  LastErrorCode=lpDSB->Lock(0,lpW->GetWaveSize(),&lpDest,&dwBytes,
    &lpDest2,&dwBytes2,DSBLOCK_ENTIREBUFFER);
  if((LastErrorCode!=DS_OK)||(dwBytes!=lpW->GetWaveSize()))
  {
    lpDSB->Release();
    Report("%s->CreateBuffer:\n"
      "  IDirectSoundBuffer->Lock",szSelf);
    LastErrorCode=DSERR_GENERIC;
    delete lpW;
    return -1;
  }
  lpW->LoadBits(lpDest);
  lpDSB->Unlock(lpDest,dwBytes,lpDest2,dwBytes2);
  alpDSB[iBuffer]=lpDSB;
  aAttachedSounds[iBuffer]=lpW;
  //  CWave   
  aOwners[iBuffer]=soSelf;
  return iBuffer;
}

void CSoundEngine::PlayBuffer(int iBuffer)
{
  IDirectSoundBuffer *lpDSB=NULL;
  if((alpDSB==NULL)||(aAttachedSounds==NULL))
  {
    Report("%s->PlayBuffer:   ",szSelf);
    return;
  }
  if((iBuffer<0)||(iBuffer>=dwMaxDsBuffers)||
     ((lpDSB=alpDSB[iBuffer])==NULL)) 
  {
    Report("%s->PlayBuffer:  \n"
      "    %ld",szSelf,iBuffer);
    return;
  }
  lpDSB->SetCurrentPosition(0);
  LastErrorCode=lpDSB->Play(0,0,0);
}

void CSoundEngine::SetVolume(int iBuffer, long lVolume)
{
  if((alpDSB==NULL)||(aAttachedSounds==NULL)) return;
  if((iBuffer<0)||(iBuffer>=dwMaxDsBuffers)) return;
  IDirectSoundBuffer *lpDSB=alpDSB[iBuffer];
  if(lpDSB==NULL) return;
  LastErrorCode=lpDSB->SetVolume(lVolume);
}

void CSoundEngine::SetPan(int iBuffer, long lPan)
{
  if((alpDSB==NULL)||(aAttachedSounds==NULL)) return;
  if((iBuffer<0)||(iBuffer>=dwMaxDsBuffers)) return;
  IDirectSoundBuffer *lpDSB=alpDSB[iBuffer];
  if(lpDSB==NULL) return;
  LastErrorCode=lpDSB->SetPan(lPan);
}

void CSoundEngine::SetFrequency(int iBuffer, long lFrequency)
{
  if((alpDSB==NULL)||(aAttachedSounds==NULL)) return;
  if((iBuffer<0)||(iBuffer>=dwMaxDsBuffers)) return;
  IDirectSoundBuffer *lpDSB=alpDSB[iBuffer];
  if(lpDSB==NULL) return;
  LastErrorCode=lpDSB->SetFrequency(lFrequency);
}

void CSoundEngine::ReleaseBuffer(int iBuffer)
{
  if((alpDSB==NULL)||(aAttachedSounds==NULL)||(aOwners==NULL)) return;
  if((iBuffer<0)||(iBuffer>=dwMaxDsBuffers)) return;
  if(alpDSB[iBuffer]==NULL) return;
  alpDSB[iBuffer]->Release();
  alpDSB[iBuffer]=NULL;
  delete aAttachedSounds[iBuffer];
  aAttachedSounds[iBuffer]=NULL;
}















class CSndWnd : public CWindowBase
{
  CSoundEngine  *lpSE;
public:
  DWORD         OverrideDefaults(int iDefault)
  {
    switch(iDefault)
    {
      case OD_TITLE: return (DWORD)"DirectSound sample";
    }
    return OD_DEFAULT;
  }
  void          OnInitialUpdate();
  long          OnEvent(UINT message, WPARAM wParam,LPARAM lParam);
  BOOL          OnClose();
};

void CSndWnd::OnInitialUpdate()
{
  lpSE = new CSoundEngine(GetWnd(),64);
  if(lpSE->LastError())
  {
    delete lpSE;
    lpSE=NULL;
    Report("Failed to create SE");
    return;
  }
  lpSE->CreateBuffer("jones.wav");
  lpSE->CreateBuffer("jones.wav");
  lpSE->CreateBuffer("jones.wav");
  lpSE->CreateBuffer("jones.wav");
  if(lpSE->LastError())
  {
    delete lpSE;
    lpSE=NULL;
    Report("Failed to create buffers");
    ::ExitProcess(-1);
  }
  lpSE->SetVolume(3,0);
  lpSE->SetVolume(2,-100);
  lpSE->SetVolume(1,-300);
  lpSE->SetVolume(0,-500);
}

long CSndWnd::OnEvent(UINT message, WPARAM wParam,LPARAM lParam)
{
  switch(message)
  {
    if(lpSE)
    {
      case WM_KEYDOWN:
      {
        switch(wParam)
        {
          case '1':
            lpSE->PlayBuffer(0);
            return 0;
          case '2':
            lpSE->PlayBuffer(1);
            return 0;
          case '3':
            lpSE->PlayBuffer(2);
            return 0;
          case '4':
            lpSE->PlayBuffer(3);
            return 0;
        }
      }
    }
  }
  return 1;
}

BOOL CSndWnd::OnClose()
{
  if(lpSE) delete lpSE;
  return TRUE;
}

int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
    CSndWnd win;
    if(!win.CreateAndShow( hInstance, nCmdShow ))
    {
      MessageBox( NULL, "Error creating window", "WinMain", MB_OK |
                  MB_ICONHAND );
      return FALSE;
    }
    win.bSuspend=FALSE;
    HDC dc=GetDC(win.GetWnd());
    TextOut(dc,10,10,"All Ok",6);
    ReleaseDC(win.GetWnd(),dc);
    return win.MessageLoop();
}
