/*<html><body bgcolor=#B4C4B0><font color=#000000><strong><pre>*/
#ifndef	V_SCHED_H
#define V_SCHED_H

typedef	void	(V_CALL	*thread_proc_t)(void *arg);
typedef void	*thread_t;
typedef void	*mutex_t;

#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
	/*	Thread API ==================================================== */
	/*	Caller - side */
	thread_t	V_GLOBAL	threadCreate(thread_proc_t start_address,
		void *arg);
	/*	Waits for thread termination */
	vboolean	V_GLOBAL	threadJoin(thread_t thread,u32_t *exit_code);
	/*	Thread - side (call is NOT necessary; if thread routine returns, 
	 *	zero exit code assumed) */
	void		V_GLOBAL	threadExit(u32_t exit_code);
	/*	TSD setting / getting */
	void		V_GLOBAL	threadSetSpecific(void_p specific);
	void_p		V_GLOBAL	threadGetSpecific(void);
	/*	Mutex API ===================================================== */
	/*	Creates new or opens existing mutex */
	mutex_t		V_GLOBAL	mutexCreate();
	/*	Aquires mutex (warning: BLOCKING call !) */
	void		V_GLOBAL	mutexLock(mutex_t mutex);
	/*	Returns 'true' if mutex is aquired, otherwise immidiately 
	 *	returns 'false' */
	vboolean	V_GLOBAL	mutexTryLock(mutex_t mutex);
	/*	Relases mutex */
	void		V_GLOBAL	mutexUnlock(mutex_t mutex);
	/*	Destroys mutex object */
	void		V_GLOBAL	mutexDestroy(mutex_t mutex);
#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */

#endif	/* V_SCHED_H */
/*</pre></strong></body></html>*/
/*EOF*/
