#include <v_lib.h>

int
main(int argc,char *argv[])
{
	int w,h;
	u8_t *tex;
	miphead_p mip;
	char namein[_MAX_PATH];
	char nameout[_MAX_PATH];
	char ext[_MAX_EXT];
	puts("TGA to MIP converter ver 1.0b. Smirnov V.A., 2000.");
	if(argc<2 || argc>3 || !strcmp(argv[1],"--help"))
	{
		puts("Usage: tga2mip <file[.tga][.jpg][.bmp]> [file[.mip]]");
		return 0;
	}
	strCopy(namein,argv[1],_MAX_PATH);
	fsDos2Unix(namein);
	fsSplitPath(namein,NULL,NULL,NULL,ext);
	if(argc==2)
  		fsReplaceExt(nameout,namein,"mip");
	else
	{
		strCopy(nameout,argv[2],_MAX_PATH);
		fsDos2Unix(nameout);
	}
	if(!strcmp(ext,"jpg"))
		tex=jpgLoad(namein,&w,&h);
	else
		if(!strcmp(ext,"bmp"))
			tex=bmpLoad(namein,&w,&h);
		else
		{
			printf("Unknown extension '%s'; assuming TGA.\n",ext);
			tex=tgaLoad(namein,&w,&h);
		}
	if(!tex)
	{
		printf("Can't load source image '%s'\n",namein);
		return -1;
	}
	mip=mipBuild(tex,w,h,4);
	if(!mip)
	{
		printf("Iternal error: mipBuild() failed.\n");
		free(tex);
		return -1;
	}
	mipSave(nameout,mip);
	free(tex);
	free(mip);
	return 0;
}
