/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#include	"../include/v_lib.h"
#include	"../source/v_mt.h"
#include	"v_os.h"

thread_data_t		__thread_data=
{
	0xFF,             /* constant_alpha - opaque */
	1000,1000,		  /* metafile extents */
	NULL,             /* log_file */
	LOG_ERROR         /* log_upper_level */
	/* All other members must be 0/NULL */
};

void	V_GLOBAL
libvFree(void *block)
{
	free(block);
}

void_p	V_GLOBAL
libvMalloc(u32_t size)
{
	return malloc(size);
}

#ifdef	MULTITHREADED

vboolean	V_GLOBAL
thrSetSpecific(u32_t slot,void *value)
{
	if(slot>=MAX_THR_SLOTS)
		return false;
	GetThreadData()->thr_specific_slots[slot]=value;
	return true;
}

vboolean	V_GLOBAL
thrGetSpecific(void **value,u32_t slot)
{
	if(slot>=MAX_THR_SLOTS)
		return false;
	*value=GetThreadData()->thr_specific_slots[slot];
	return true;
}

#endif	/* MULTITHREADED */

#ifdef	__WIN32__

LONG		V_LOCAL	detected_must_die=-1;

vboolean	V_GLOBAL
WeAreUnderMustDie(void)
{
	if(detected_must_die==-1)
	{
		LONG md;
		OSVERSIONINFO vi;
		v_zero(&vi,sizeof(OSVERSIONINFO));
		vi.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
		GetVersionEx(&vi);
		md=vi.dwPlatformId != VER_PLATFORM_WIN32_NT ? 1 : 0;
		InterlockedExchange(&detected_must_die,md);
	}
	return (vboolean)detected_must_die;
}

#ifdef	BUILD_DLL

#ifndef	MULTITHREADED

/* 		Quiet "Non-referenced formal parameter" warning */
#if		defined(_MSC_VER)
#pragma warning(disable:4100)
#elif	defined(__BORLANDC__)
#pragma	argsused
#endif	/* defined(_MSC_VER) */

BOOL WINAPI
DllMain(HINSTANCE hInstance,DWORD fdwReason,LPVOID lpvReserved)
{
	return TRUE;
}

#else		/* MULTITHREADED */

static		DWORD					tls_key = 0xFFFFFFFF;
#define		STORAGE_SIZE			(sizeof(thread_data_t))

vboolean	V_GLOBAL
libvPerThreadInit(void)
{
	void *storage;
	storage=malloc(STORAGE_SIZE);
	if(!storage)
	{
#ifdef	CHECKED_BUILD
		char buf[256];
		sprintf(buf,"libvPerThreadInit(): Can't attach to thread %d: "
			"unable to allocate %d bytes for thread local storage.\n",
			GetCurrentThreadId(),STORAGE_SIZE);
		MessageBox(NULL,buf,"LibV",MB_OK|MB_ICONHAND);
#endif	/* CHECKED_BUILD */
		return false;
	}
	if(!TlsSetValue(tls_key,storage))
	{
#ifdef	CHECKED_BUILD
		char buf[256];
		sprintf(buf,"libvPerThreadInit(): Can't attach to thread %d: "
			"TlsSetValue(%d,%X) failed with error code %d.\n",
			GetCurrentThreadId(),tls_key,storage,GetLastError());
		MessageBox(NULL,buf,"LibV",MB_OK|MB_ICONHAND);
#endif	/* CHECKED_BUILD */
		return false;
	}
	v_copy(storage,&__thread_data,STORAGE_SIZE);
	return true;
}

vboolean	V_GLOBAL
libvPerProcessInit(void)
{
	tls_key=TlsAlloc();
	if(tls_key==0xFFFFFFFF)
	{
#ifdef	CHECKED_BUILD
		/* Cant use conlPrintf ! */
		MessageBox(NULL,
			"libvPerProcessInit(): unable to allocate TLS index.","LibV",
			MB_OK|MB_ICONHAND);
#endif	/* CHECKED_BUILD */
		return false;
	}
	return libvPerThreadInit();
}

vboolean	V_GLOBAL
libvPerThreadShutdown(void)
{
	void *storage;
	storage=TlsGetValue(tls_key);
	if(storage)
	{
		free(storage);
		return true;
	}
	return false;
}

vboolean	V_GLOBAL
libvPerProcessShutdown(void)
{
	libvPerThreadShutdown();
	TlsFree(tls_key);
	return true;
}
	
thread_data_p V_GLOBAL
GetThreadData(void)
{
	return (thread_data_p)TlsGetValue(tls_key);
}

#if		defined(_MSC_VER)
#pragma warning(disable:4100)
#elif	defined(__BORLANDC__)
#pragma	argsused
#endif	/* defined(_MSC_VER) */

BOOL WINAPI
DllMain(HINSTANCE hInstance,DWORD fdwReason,LPVOID lpvReserved)
{
	switch(fdwReason)
	{
		case DLL_PROCESS_ATTACH:
			return libvPerProcessInit() ? TRUE : FALSE;
		case DLL_THREAD_ATTACH:
			return libvPerThreadInit() ? TRUE : FALSE;
		case DLL_THREAD_DETACH:
			return libvPerThreadShutdown() ? TRUE : FALSE;
		case DLL_PROCESS_DETACH:
			return libvPerProcessShutdown() ? TRUE : FALSE;
	}
	return TRUE;
}

#endif	/* MULTITHREADED */

#endif	/* BUILD_DLL */

#elif	defined(__UNIX__)	/* __WIN32__ */


/*
#error	TODO: Implement UNIX TLS via pthread calls.
*/
#elif	defined(__DOS32__)	/* defined(__UNIX__) */
#error	TODO: Implement DOS TLS stubs.
#endif	/* defined(__DOS32__) */

/*</pre></strong></body></html>*/
/*EOF*/
