/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#ifndef   V_MT_H
#define   V_MT_H

/*	======================================================================
 *	Here are private declarations which are needed only by libv itself.
 *	======================================================================
 */

/*	From v_log.cpp:
 */
#define	LOG_MAX_DEST				4

/*	From v_paklib.cpp:
 */
#define	MAX_PAKFILES				16
#define	MAX_FILES_IN_PACK			4096
/*	Actual size of rhandles storage is MAX_OPENFILES+1 because entry #0
 *	is reserved for error detection.
 */
#define	MAX_OPENFILES				127
#define	IDPAKHEADER					(('K'<<24)+('C'<<16)+('A'<<8)+'P')

typedef struct
{
	char	name[56];
	i32_t	filepos, filelen;
}	dpackfile_t, *dpackfile_p;

typedef struct
{
	u32_t		ident;
	u32_t		dirofs;
	u32_t		dirlen;
}	dpackheader_t, *dpackheader_p;

typedef struct pak_info_s
{
	char		path[_MAX_PATH];
	u32_t		dirofs,numres;
	FILE		*fhandle;	/* returned by fopen */
	dpackfile_t	dir[1];
}	pak_info_t, *pak_info_p;

typedef struct resrc_s
{
	/* Number of resource in PAK directory */
	u32_t		dirnum;
	/* Number of PAK file */
	u32_t		paknum;
	/* Offset of start of resource in PAK */
	u32_t		sstart;
	/* Offset of last byte of resource + 1 in PAK */
	u32_t		send;
	/* Current offset in PAK */
	u32_t		scur;
	/* Handle of external file */
	FILE		*fhandle;
}	resrc_t, *resrc_p;

/*
 *	Thread local storage.
 */
typedef struct      thread_data_s
{
	/*					v_image.c */
	u8_t				constant_alpha;
	/*					v_wmf.c */
	u32_t				meta_x_extent,meta_y_extent;
	/*					v_log.c */
	FILE				*log_file;
	u32_t				log_upper_level;
	void				(V_CALL *log_callbacks[LOG_MAX_DEST])(char *str);
	/*					v_fs.c */
	u32_t				num_pak_files;
	pak_info_t			*pak_files[MAX_PAKFILES];
	i32_t				numres;
	resrc_p				reshandles[MAX_OPENFILES+1];
	/*					v_gl.c */
	u32_t				gl_current_slot_plus_1;
	vboolean			lower_case;
	vboolean			caps_lock;
	vboolean			num_lock;
	/*					v_incon.c */
	u32_t				con_prev_mouse_flags;
	/*					v_time.c */
	u32_t				Ticking;
	u32_t				StartMilliseconds;
#ifdef	MULTITHREADED
	void_p				tss_specific;
#define	MAX_THR_SLOTS	256
	/*	Extra slots */
	void_p				thr_specific_slots[MAX_THR_SLOTS];
#endif	/* MULTITHREADED */
}	thread_data_t, *thread_data_p;

#ifndef MULTITHREADED
extern  thread_data_t			__thread_data;
#define GetThreadData()			(&__thread_data)
#else	/* MULTITHREADED */
thread_data_p V_GLOBAL			GetThreadData(void);
#endif	/* MULTITHREADED */

/*
 *	local OS - independent prototypes
 */

/*	Vertex drawing function */
typedef	void (*vertex_draw_proc_t)(vec_t *v,vec_t *c,vec_t *n,vec_t *t);
/*	Triangle drawing function */
typedef	void (*tri_draw_proc_t)(tlist_face_t *tri);
/*	Draw flags */
#define	NORMAL_DRAW_BIT			1
#define	TEXTURE_DRAW_BIT		2
#define	COLOR_DRAW_BIT			4

/*	Draw procs */
#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
	u32_t			V_GLOBAL	vglGetDrawBits(void);
	vertex_draw_proc_t	V_GLOBAL	vglGetVertexDrawProc(int draw_bits);
	tri_draw_proc_t	V_GLOBAL	vglGetTriangleDrawProc(int draw_bits);
#ifdef	__cplusplus
}
#endif	/* __cplusplus */

/*
 *	OS - dependent prototypes, local to library itself.
 */
#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
#ifdef	__WIN32__
	/*				WE ALWAYS WILL LOVE WINDOWS 95 !!! 				*/
	/*	Returns false if we are under NT, otherwise returns true.	*/
	vboolean	V_GLOBAL	WeAreUnderMustDie(void);
#endif	/* __WIN32__ */
#ifdef	__cplusplus
}
#endif	/* __cplusplus */

#endif	/* V_MT_H */

/*</pre></strong></body></html>*/
/*EOF*/
