/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#include	"../include/v_lib.h"
#include	"../source/v_mt.h"

parser_p	V_GLOBAL
tokStart(char *buffer,char *delim)
{
	parser_p t;
	if(!buffer)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"tokStart('[NULL]','%s'): incorrect parameter.\n",dbs(delim));
#endif
		return NULL;
	}
	t=(parser_p)malloc(sizeof(parser_t));
	v_zero(t,sizeof(parser_t));
	t->tos=t->unget=0;
	t->token_ptr=t->token_buffer=buffer;
	if(delim)
		strCopy(t->delim,delim,MAX_DELIMITERS);
	return t;
}

parser_p	V_GLOBAL
tokStartFile(char *filename,char *delim)
{
	parser_p t;
	file_t infile;
	int insize;
	if(!filename || !delim)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"tokStartFile('%s','%s'): incorrect parameter.\n",
			dbs(filename),dbs(delim));
#endif
		return NULL;
	}
	infile=fileOpenRead(filename);
	if(!infile)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"tokStartFile('%s','%s'): can't open file.\n",
			dbs(filename),dbs(delim));
#endif
		return NULL;
	}
	insize=fileSize(infile);
	if(!insize)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"tokStartFile('%s','%s'): empty file.\n",
			dbs(filename),dbs(delim));
#endif
		fileClose(infile);
		return NULL;
	}
	t=(parser_p)malloc(sizeof(parser_t)+insize+1);
	v_zero(t,sizeof(parser_t)+insize+1);
	t->tos=t->unget=0;
	t->token_ptr=t->token_buffer=(char*)(t+1);
	if(fileRead(infile,t->token_buffer,insize)!=insize)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"tokStartFile('%s','%s'): can't read %d bytes.\n",
			dbs(filename),dbs(delim),insize);
#endif
		free(t);
		fileClose(infile);
		return NULL;
	}
	if(delim)
		strCopy(t->delim,delim,MAX_DELIMITERS);
	return t;
}

void	V_GLOBAL
tokRestart(parser_p tok)
{
	V_ASSERT(tok);
	tok->token_ptr=tok->token_buffer;
	tok->tos=0;
}

i32_t	V_GLOBAL
tokPush(parser_p tok)
{
	V_ASSERT(tok);
	if(tok->tos==MAX_TOKENPOSSTACK)
		return 0;
	tok->posstack[tok->tos++]=tok->token_ptr;
	return 1;
}

i32_t	V_GLOBAL
tokPop(parser_p tok)
{
	V_ASSERT(tok);
	if(!tok->tos)
		return 0;
	tok->token_ptr=tok->posstack[--tok->tos];
	return 1;
}

void	V_GLOBAL
tokDelim(parser_p tok,char *delim)
{
	V_ASSERT(tok && delim);
	strCopy(tok->delim,delim,MAX_DELIMITERS);
}

char_p	V_GLOBAL
tokNext(parser_p tok)
{
	int i=0;
	V_ASSERT(tok);
	if(!*tok->token_ptr)
		return NULL;
	if(tok->unget)
	{
		tok->unget=0;
		return tok->token;
	}
	for(;*tok->token_ptr<=32 && *tok->token_ptr;tok->token_ptr++);
	if(!*tok->token_ptr)
		return NULL;
	if(*tok->token_ptr=='"')
	{
		for(tok->token_ptr++;*tok->token_ptr != '"' && *tok->token_ptr
							 && i<MAX_TOKENSIZE;tok->token_ptr++,i++)
			tok->token[i]=*tok->token_ptr;
		if(*tok->token_ptr=='"')
			tok->token_ptr++;
		tok->token[i]=0;
	}
	else
	{
		if(strchr(tok->delim,*tok->token_ptr))
		{
			tok->token[0]=*tok->token_ptr;
			tok->token[1]=0;
			tok->token_ptr++;
		}
		else
		{
			while((i<MAX_TOKENSIZE) && !strchr(tok->delim,*tok->token_ptr)
					&& *tok->token_ptr>32)
			{
				tok->token[i]=*tok->token_ptr;
				tok->token_ptr++;
				i++;
			}
			tok->token[i]=0;
		}
	}
	return tok->token;
}

char_p	V_GLOBAL
tokString(parser_p tok)
{
	int i;
	V_ASSERT(tok);
	if(!*tok->token_ptr)
		return NULL;
	for(;(*tok->token_ptr == 0x0d || *tok->token_ptr==0x0a) && 
		*tok->token_ptr; tok->token_ptr++);
	if(!*tok->token_ptr)
		return NULL;
	i=0;
	while(*tok->token_ptr!=0x0d && *tok->token_ptr!=0x0a && 
		i<MAX_TOKENSIZE && *tok->token_ptr)
	{
		tok->token[i]=*tok->token_ptr;
		tok->token_ptr++;
		i++;
	}
	tok->token[i]=0;
	return tok->token;
}

char_p	V_GLOBAL
tokLast(parser_p tok) 
{
	V_ASSERT(tok);
	return tok->token;
}

/*</pre></strong></body></html>*/
/*EOF*/
