/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#include	"../include/v_lib.h"
#include	"../source/v_mt.h"
#include	"v_os.h"

#ifdef		__WIN32__
#define		ke_delay_execution(milliseconds)	Sleep(milliseconds)
#define		ke_tick_count						GetTickCount
#else

unsigned	V_LOCAL
ke_tick_count(void)
{
#if		CLOCKS_PER_SEC==100		/* WATCOM C */
	return clock() * 10;
#elif	CLOCKS_PER_SEC==1000
	return clock();
#elif	CLOCKS_PER_SEC==1000000	/* true under linux */
	return clock() / 1000;
#else
	return (unsigned)((double)1000.0*clock()/(double)CLOCKS_PER_SEC);
#endif
}

void	V_LOCAL
ke_delay_execution(unsigned milliseconds)
{
#if	defined(__DOS32__) && defined(__WATCOMC__)
	/* WATCOM C provides delay() in i86.h */
	delay(milliseconds);
#elif	defined(__UNIX__)
	usleep(milliseconds * 1000);
#else	/* we are not in UNIX; emulate usleep() */
	int seconds, clk, ms;
	seconds = (int)(milliseconds / 1000);
	ms = (int)(milliseconds - seconds * 1000);
	sleep(seconds);
	clk=clock();
	/* I'll implement some sort of sheduler, I promise ... */
	/* DON'T LOOK HERE !!! */
	while((clock()-clk)<ms);
#endif
}

#endif	/* __WIN32__ */

/*
void	V_GLOBAL
timeStart()
{
	thread_data_t *td;
	td=GetThreadData();
	td->StartMilliseconds = ke_tick_count();
	td->Ticking = 1;
}

void	V_GLOBAL
timeStop()
{
	thread_data_t *td;
	td=GetThreadData();
	td->StartMilliseconds = ke_tick_count() - td->StartMilliseconds;
	td->Ticking = 0;
}

u32_t	V_GLOBAL
timeMilliseconds()
{
	thread_data_t *td;
	td=GetThreadData();
	if(td->Ticking)
		return ke_tick_count() - td->StartMilliseconds;
	else
		return td->StartMilliseconds;
}
*/

void	V_GLOBAL
timeDelay(u32_t Milliseconds)
{
	ke_delay_execution(Milliseconds);
}

/*
 *	Sets timer to active state.
 */
void	V_GLOBAL
timerStart(timer_t *timer)
{
	V_ASSERT(timer);
	timer->active=true;
	timer->time_start=ke_tick_count();
}

/*
 *	Sets timer to passive state: subsequent calls of timerMilliseconds()
 *	return time at the moment of this call.
 */	
void	V_GLOBAL
timerStop(timer_t *timer)
{
	V_ASSERT(timer);
	timer->active=false;
	timer->time_start=ke_tick_count();
}

u32_t	V_GLOBAL
timerMilliseconds(timer_t *timer)
{
	V_ASSERT(timer);
	if(timer->active)
		return ke_tick_count() - timer->time_start;
	else
		return timer->time_start;
}

void	V_GLOBAL
timerWait(timer_t *timer,u32_t return_time)
{
	u32_t delay_time=return_time-timerMilliseconds(timer);
	ke_delay_execution(delay_time);
}

/*</pre></strong></body></html>*/
/*EOF*/
